#ifndef Hospital_h
#define Hospital_h 1

#pragma warning(disable:4786)
#include <string>
#include <set>

class Patient;
typedef std::set<Patient*> PatientRoster;

class Hospital 
{
public:
    std::string getName() const {return mName;}
    void setName(const std::string &n) {mName = n;}

    void addPatient(Patient *p) {mPatients.insert(p);}
    void removePatient(Patient *p) {mPatients.erase(p);}

    PatientRoster::iterator begin() {return mPatients.begin();}
    PatientRoster::iterator end() {return mPatients.end();}

    // Assumption:  Only one hospital in the program.
    static Hospital &theHospital();
private:
    Hospital() {} // Only theHospital() can create a hospital.
    Hospital & operator=(const Hospital &right); //Disallow
    Hospital(const Hospital &); //Disallow

    std::string mName;
    
    PatientRoster mPatients;
};

#endif
