#ifndef Patient_h
#define Patient_h 1

#include <string>
#include <list>
using namespace std;

class Doctor;
class Measurement;

typedef std::list<Measurement *> Measurements;

class Patient 
{
public:
    Patient();
    ~Patient();

    string getName() const {return mName;}
    void setName(const string &n) {mName = n;}

    string getAccountNo() const {return mAccountNo;}
    void setAccountNo(const string &n) {mAccountNo = n;}

    Doctor *getDoctor() const {return mAssignedDoctor;}
    void setDoctor(Doctor *d) {mAssignedDoctor = d;}

    void releaseFromHospital();

    void addMeasurement(Measurement *m) {mMeasurements.push_back(m);}

    void printMeasurements(std::ostream &os) const;

private:
    Patient & operator=(const Patient &right); // Disallow
    Patient(Patient const &); // Disallow

    string mName;
    string mAccountNo;
    Doctor *mAssignedDoctor;
    Measurements mMeasurements;
};

std::ostream operator<<(std::ostream &os,Patient const &p);


#endif
