#include <assert.h>
#include <iostream>
#include "Time.h"

void Time::set(int year, int month, int day, int hour, int min, int sec)
{
    // We follow struct tm conventions except for year, which
    // is 4 digits:
    assert(year > 99); // Check for Y2K problems

    struct tm t;
    t.tm_year = year - 1900;
    t.tm_mon = month;
    t.tm_mday = day;
    t.tm_hour = hour;
    t.tm_min = min;
    t.tm_sec = sec;

    time_t newTime = mktime(&t);
    assert(newTime != (time_t)-1);
    mTime = newTime;
}

void Time::get(int *year, int *month, int *day, int *hour, 
               int *min, int *sec) const
{
    std::cerr << "Time::get() called" << std::endl;
}

std::ostream &operator<<(std::ostream &os,Time const & t)
{
    time_t secs = t.mTime;
    return os << ctime(&secs);
}
